#!/usr/bin/env python
#-*- encoding:utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2011 TeMPO Consulting, MSF. All Rights Reserved
#    Developer: Olivier DOSSMANN
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv
from osv import fields
from tools.translate import _

class wizard_temp_posting(osv.osv_memory):
    _name = "wizard.temp.posting"

    def action_confirm_temp_posting(self, cr, uid, ids, context={}):
        """
        Temp post some statement lines
        """
        if 'active_ids' in context:
            # Retrieve statement line ids
            st_line_ids = context.get('active_ids')
            # Browse statement lines
            for st_line_id in st_line_ids:
                # Verify that the line is in draft state ('Empty')
                st_line = self.pool.get('account.bank.statement.line').browse(cr, uid, [st_line_id])[0]
                state = st_line.state
                if state == 'draft':
                    # If in the good state : temp posting !
                    self.pool.get('account.bank.statement.line').button_temp_posting(cr, uid, [st_line_id], context=context)
            mod_obj = self.pool.get('ir.model.data')
            act_obj = self.pool.get('ir.actions.act_window')
            # action_cheque_register_tree = Cheque Register
            # action_view_bank_statement_tree = Cash Register
            # action_bank_statement_tree = Bank Register
            st_type = st_line.statement_id.journal_id.type
            module = 'account'
            mod_action = 'action_view_bank_statement_tree'
            if st_type:
                if st_type == 'cash':
                    mod_action = 'action_view_bank_statement_tree'
                elif st_type == 'bank':
                    mod_action = 'action_bank_statement_tree'
                elif st_type == 'cheque':
                    mod_action = 'action_cheque_register_tree'
                    module = 'register_accounting'
            result = mod_obj._get_id(cr, uid, module, mod_action)
            id = mod_obj.read(cr, uid, [result], ['res_id'], context=context)[0]['res_id']
            result = act_obj.read(cr, uid, [id], context=context)[0]
            result['res_id'] = st_line.statement_id.id
            result['view_mode'] = 'form,tree,graph'
            views_id = {}
            for (num, typeview) in result['views']:
                views_id[typeview] = num
            result['views'] = []
            for typeview in ['form','tree','graph']:
                if views_id.get(typeview):
                    result['views'].append((views_id[typeview], typeview))
            result['target'] = 'crush'
            return result
        else:
            raise osv.except_osv(_('Warning'), _('You have to select some lines before using this wizard.'))

wizard_temp_posting()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
